//
//  ViewController.m
//  淘宝详情中的动画
//
//  Created by zhou on 16/9/14.
//  Copyright © 2016年 zhou. All rights reserved.
//
#define ScreenWidth [UIScreen mainScreen].bounds.size.width
#define ScreenHeight [UIScreen mainScreen].bounds.size.height

#import "ViewController.h"

@interface ViewController ()<UITableViewDataSource,UITableViewDelegate,UIScrollViewDelegate>

@property (nonatomic, strong) UITableView *tableView;

@property (nonatomic, strong) UIView *headerView;
/** 指示器 */
@property (nonatomic, strong) UIPageControl *pageControl;
/** 滚动图片的scrollView和指示器的共同父view */
@property (nonatomic, strong) UIScrollView *headerScrollView;
/** 滚动图片的scrollView */
@property (nonatomic, strong) UIScrollView *scrollView;

@end

@implementation ViewController

- (UITableView *)tableView
{
    if (_tableView == nil) {
        _tableView = [[UITableView alloc] init];
        _tableView.frame = CGRectMake(0, 0, ScreenWidth, ScreenHeight);
        [self.view addSubview:_tableView];
    }
    return _tableView;
}
- (void)viewDidAppear:(BOOL)animated
{
    self.navigationController.navigationBar.alpha = 0;
}
- (void)viewDidLoad {
    [super viewDidLoad];
    
    self.automaticallyAdjustsScrollViewInsets = NO;
    
    self.tableView.delegate = self;
    self.tableView.dataSource = self;
    [self createHeader];
    self.tableView.tableHeaderView = self.headerView;
    
}

- (void)createHeader
{
    int count = 5;
    //
    UIView *headerView = [[UIView alloc] init];
    self.headerView = headerView;
    headerView.backgroundColor = [UIColor redColor];
    headerView.frame = CGRectMake(0, 0, ScreenWidth, ScreenWidth);
    //
    UIScrollView *headerScrollView = [[UIScrollView alloc] initWithFrame:headerView.bounds];
    self.headerScrollView = headerScrollView;
    [headerView addSubview:headerScrollView];
    
    UIScrollView *scrollView = [[UIScrollView alloc] initWithFrame:headerScrollView.bounds];
    self.scrollView = scrollView;
    scrollView.delegate = self;
    
    // 添加多张图片
    for (int i=0; i < count; i++) {
        UIImageView *imageView = [[UIImageView alloc] initWithFrame:CGRectMake(i*ScreenWidth, 0, ScreenWidth, ScreenWidth)];
        imageView.image = [UIImage imageNamed:@(i+1).stringValue];
        [scrollView addSubview:imageView];
    }
    scrollView.pagingEnabled = YES;
    scrollView.showsHorizontalScrollIndicator = NO;
    scrollView.contentSize = CGSizeMake(ScreenWidth * count, 0);

    [headerScrollView addSubview:scrollView];
    
    //指示器
    UIPageControl *pageControl = [[UIPageControl alloc] init];
    self.pageControl = pageControl;
    pageControl.frame = CGRectMake(0, self.scrollView.bounds.size.width-60, ScreenWidth, 37);
    pageControl.currentPage = 0;
    pageControl.numberOfPages = count;
    pageControl.currentPageIndicatorTintColor = [UIColor redColor];
    pageControl.pageIndicatorTintColor = [UIColor orangeColor];
    [headerScrollView addSubview:pageControl];
    
}
- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section
{
    return 20;
}
- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath
{
    static NSString *cellid = @"desds";
    UITableViewCell *cell = [tableView dequeueReusableCellWithIdentifier:cellid];
    if (cell == nil) {
        cell = [[UITableViewCell alloc] initWithStyle:UITableViewCellStyleSubtitle reuseIdentifier:cellid];
    }
    cell.textLabel.text = [NSString stringWithFormat:@"这是第%ld行测试数据",indexPath.row];
    return cell;
}

- (void)scrollViewDidScroll:(UIScrollView *)scrollView
{
    
    CGFloat offset = scrollView.contentOffset.y;
    
    if (scrollView == self.tableView) {
        
        // 重新赋值，就不会有用力拖拽时的回弹
        self.headerScrollView.contentOffset = CGPointMake(self.headerScrollView.contentOffset.x, 0);
        
        if (offset <= ScreenWidth && self.tableView.contentOffset.y > 0) {
            
            self.headerScrollView.contentOffset = CGPointMake(self.headerScrollView.contentOffset.x, -offset / 2.0f);
            self.navigationController.navigationBar.alpha = offset / ScreenWidth;
        }
        //下面的两个else if都是解决用力拖拽时的问题
        else if (self.tableView.contentOffset.y <= 0)
        {
            self.navigationController.navigationBar.alpha = 0;

        }else
        {
            self.navigationController.navigationBar.alpha = 1;
        }


    }else if (scrollView == self.scrollView) {
        self.pageControl.currentPage = scrollView.contentOffset.x/ScreenWidth;
    }
    
}
@end
